<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/calc_dMdt.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>calc_dMdt.c</h1><a href="calc__dMdt_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: calc_dMdt.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;spintorq/spintorq.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a><a class="code" href="llg_8h.html#aa814b25d7c7a65198ca75426fb6d7403">00034</a> <span class="keywordtype">int</span> <a class="code" href="calc__dMdt_8c.html#aa814b25d7c7a65198ca75426fb6d7403">calc_dMdt</a>(TS ts, PetscReal dt, Vec invec, Vec outvec, <span class="keywordtype">void</span> *ptr)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   <a class="code" href="structGridData.html">GridData</a> *gdata = (<a class="code" href="structGridData.html">GridData</a>*)ptr;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <span class="comment">/* DEBUG</span>
<a name="l00041"></a>00041 <span class="comment">  assert(gdata-&gt;M==invec);</span>
<a name="l00042"></a>00042 <span class="comment">  */</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   PetscReal *ta_M, *ta_Htot, *ta_outvec;
<a name="l00047"></a>00047   VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);
<a name="l00048"></a>00048   VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00049"></a>00049   VecGetArray(outvec,&amp;ta_outvec);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>  PetscReal  *ta_Hspintorque;
<a name="l00053"></a>00053   PetscReal  *ta_Hspinforce;
<a name="l00054"></a>00054   <span class="keywordflow">if</span> (gdata-&gt;VHspintorque!=PETSC_NULL)  VecGetArray(gdata-&gt;VHspintorque,&amp;ta_Hspintorque);
<a name="l00055"></a>00055   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;VHspinforce!=PETSC_NULL) VecGetArray(gdata-&gt;VHspinforce,&amp;ta_Hspinforce);
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;i++) {
<a name="l00059"></a>00059     PetscReal *torq, damp[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00060"></a>00060     PetscReal a1,alpha;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     torq=ta_outvec+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="comment">/* skip non-magnetic vertices and vertices with alpha &gt;= RIGID_M_ALPHA */</span>
<a name="l00065"></a>00065     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+4]&lt;=0.0 ||
<a name="l00066"></a>00066         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+9]&gt;=<a class="code" href="griddata_8h.html#a8a54558688c833b1f886703d3012f1dd">RIGID_M_ALPHA</a>) {
<a name="l00067"></a>00067       torq[0]=0.0;
<a name="l00068"></a>00068       torq[1]=0.0;
<a name="l00069"></a>00069       torq[2]=0.0;
<a name="l00070"></a>00070       <span class="keywordflow">continue</span>;
<a name="l00071"></a>00071     }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,ta_Htot+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,torq);
<a name="l00074"></a>00074     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,torq,damp);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     alpha=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+9];
<a name="l00077"></a>00077     a1=1.0/(1.0+alpha*alpha);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==2 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>&lt;0) {
<a name="l00080"></a>00080       <span class="comment">/* relax with large damping and no precession */</span>
<a name="l00081"></a>00081       a1=2.0;
<a name="l00082"></a>00082       <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,damp,1,torq,1);
<a name="l00083"></a>00083       <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-a1,torq,1);
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085     <span class="keywordflow">else</span> {
<a name="l00086"></a>00086       <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-a1,torq,1);
<a name="l00087"></a>00087       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-a1*alpha,damp,1,torq,1);
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>    <span class="comment">/* FIXME: move to hspin*.c */</span>
<a name="l00092"></a>00092     PetscReal spintorq[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>], spindamp[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00093"></a>00093     <span class="keywordflow">if</span> (gdata-&gt;VHspintorque!=PETSC_NULL) {
<a name="l00094"></a>00094       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,ta_Hspintorque+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,spintorq);
<a name="l00095"></a>00095       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,spintorq,spindamp);
<a name="l00096"></a>00096       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,+a1*alpha,spintorq,1,torq,1);
<a name="l00097"></a>00097       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-a1,spindamp,1,torq,1);
<a name="l00098"></a>00098     }
<a name="l00099"></a>00099     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;VHspinforce!=PETSC_NULL) {
<a name="l00100"></a>00100       PetscReal  nonadiabatic;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102       nonadiabatic=gdata-&gt;propdat_e[NPe*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+2];
<a name="l00103"></a>00103 
<a name="l00104"></a>00104       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,ta_Hspinforce+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,spintorq);
<a name="l00105"></a>00105       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,spintorq,spindamp);
<a name="l00106"></a>00106       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-a1*nonadiabatic+a1*alpha,spintorq,1,torq,1);
<a name="l00107"></a>00107       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-a1*alpha*nonadiabatic-a1,spindamp,1,torq,1);
<a name="l00108"></a>00108     }
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>  }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);
<a name="l00113"></a>00113   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00114"></a>00114   VecRestoreArray(outvec,&amp;ta_outvec);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;VHspintorque!=PETSC_NULL)  VecRestoreArray(gdata-&gt;VHspintorque,&amp;ta_Hspintorque);
<a name="l00118"></a>00118   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (gdata-&gt;VHspinforce!=PETSC_NULL) VecRestoreArray(gdata-&gt;VHspinforce,&amp;ta_Hspinforce);
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
<a name="l00121"></a>00121   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

